Author Topic: Move dimension text up or down  (Read 895 times)

0 Members and 1 Guest are viewing this topic.

Offline fixo

  • Full Member
  • ***
  • Posts: 135
  • Karma: +4/-0
  • Gender: Male
    • prefered language: C
    • Prog expertise: Good
    • View Profile
Move dimension text up or down
« on: May 23, 2012, 07:37:45 AM »
   
Code: [Select]
    [CommandMethod("cdimup")]
        public static void TestDimUp()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Editor ed = doc.Editor;

            Database db = HostApplicationServices.WorkingDatabase;

            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                // Select a dimension

                try
                {

                    PromptEntityOptions peo = new PromptEntityOptions("\nSelect a Dimension >>");
                    peo.SetRejectMessage("\nYou have to select the Dimension only >>");
                    peo.AddAllowedClass(typeof(Dimension), false);
                    PromptEntityResult res;
                    res = ed.GetEntity(peo);
                    if (res.Status != PromptStatus.OK)
                        return;
                    Entity ent = (Entity)tr.GetObject(res.ObjectId, OpenMode.ForRead);
                    if (ent == null)
                        return;
                    Dimension dim = (Dimension)ent as Dimension;
                    if (dim == null) return;

                    if (!dim.IsWriteEnabled) dim.UpgradeOpen();

                    // Add Xdata:

                    dim.XData = new ResultBuffer(

                    new TypedValue((int)DxfCode.ExtendedDataRegAppName, "ACAD"),

                    new TypedValue((int)DxfCode.ExtendedDataAsciiString, "DSTYLE"),

                    new TypedValue((int)DxfCode.ExtendedDataControlString, "{"),

                    new TypedValue((int)DxfCode.ExtendedDataInteger16, 77),

                    new TypedValue((int)DxfCode.ExtendedDataInteger16, 1),

                    new TypedValue((int)DxfCode.ExtendedDataControlString, "}")

                          );

                    dim.DowngradeOpen();

                    tr.Commit();
                }
                catch (System.Exception ex)
                {
                    Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor.WriteMessage(ex.Message);
                }

            }

        }

   
Code: [Select]
    [CommandMethod("cdimdown")]
        public static void TestDimDown()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Editor ed = doc.Editor;

            Database db = HostApplicationServices.WorkingDatabase;

            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                // Select a dimension

                try
                {

                    PromptEntityOptions peo = new PromptEntityOptions("\nSelect a Dimension >>");
                    peo.SetRejectMessage("\nYou have to select the Dimension only >>");
                    peo.AddAllowedClass(typeof(Dimension), false);
                    PromptEntityResult res;
                    res = ed.GetEntity(peo);
                    if (res.Status != PromptStatus.OK)
                        return;
                    Entity ent = (Entity)tr.GetObject(res.ObjectId, OpenMode.ForRead);
                    if (ent == null)
                        return;
                    Dimension dim = (Dimension)ent as Dimension;
                    if (dim == null) return;

                    if (!dim.IsWriteEnabled) dim.UpgradeOpen();

                    // Add Xdata:

                    dim.XData = new ResultBuffer(

                    new TypedValue((int)DxfCode.ExtendedDataRegAppName, "ACAD"),

                    new TypedValue((int)DxfCode.ExtendedDataAsciiString, "DSTYLE"),

                    new TypedValue((int)DxfCode.ExtendedDataControlString, "{"),

                    new TypedValue((int)DxfCode.ExtendedDataInteger16, 77),

                    new TypedValue((int)DxfCode.ExtendedDataInteger16, 4),

                    new TypedValue((int)DxfCode.ExtendedDataControlString, "}")

                          );

                    dim.DowngradeOpen();
               
                    tr.Commit();
                }
                catch (System.Exception ex)
                {
                    Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor.WriteMessage(ex.Message);
                }

            }

        }

~'J'~